/*
2025-04-21
Michael Nowak
http://www.mino-elektronik.de
Alle Angaben ohne Gewaehr !
*/

#ifndef ROM_SIMUL_H
#define ROM_SIMUL_H
#include "ctype.h"  
#include "rp2040.h"

#define BIT(x) (1<<x)

#define DEF_SYSCLOCK     200000000  // default fuer <= 120 ns Zugriffszeit
#define MHZ_12            12000000  // default
#define AS6501_REF        10000000  // TCXO or ext. clock

#define MHZ_FAKTOR        1000000   // 1e6
#define MS_TEILER         1000      // us -> ms

#define REF_DIV           2         // PLL-Schrittweite 6 MHZ @ 12 MHz
#define PLL_DIV1          3         // force high F_vco
#define PLL_DIV2          2         // default = 2; 1 => turbo-mode

enum {PRIO_HIGH = 0, PRIO_MID_HIGH, PRIO_MID_LOW, PRIO_LOW};

#define LOCAL_LED         25

#define DEF_BAUDRATE      500000L
#define MAX_ROM_SIZE      0x8000    // 32 KB emulieren
#define MIN_ROM_SIZE      0x1000    // 4 kB minimal (2732)
#define ROM_DATEN_START   0x10000   // physikalische Adresse im FLASH
#define STD_ROM_DATEN     (0x13000000 + ROM_DATEN_START) // aus FLASH-ROM ohne Cache-Zugriffe

// fuer Programm im RAM
#define CODESTART         0x10000000      // urspruenlicher Code
#define RAMSTART          0x15000000      // neue Adresse fuer Code im Cache von XIP
#define CODESIZE_8KB      0x2000          // max. Codegroesse

#endif